<?php

    include('../application_helper.php');
    $output['result'] = false;
    $output['message'] = "Something went wrong";
    if($data = validate_post_data(['access_token', 'admin_id', 'district_title'])){
        include('../db.php');
        if(validate_admin($connection,  $data['access_token'], $data['admin_id'])){
            if(is_super_admin($connection, $data['admin_id'])){
                if(is_already_exist($connection, $data['district_title'])){
                    $output['result'] = false;
                    $output['message'] = "District name already exist";
                } else { 
                    $query = "INSERT INTO district_details(district_name ) VALUES(?)";
                    $stmt=$connection->prepare($query);
                    $stmt->bind_param("s",$data['district_title']);
                    $stmt->execute();
                    $stmt->close();
                    $output['result'] = true;
                    $output['message'] = "Successfully created new district";
                }
            }
        }
    }  
    print_as_json($output);
    
    function is_already_exist($connection , $title){
        $query = "Select * FROM district_details WHERE district_name = ?";
        $stmt=$connection->prepare($query);
        $stmt->bind_param("s", $title);
        $stmt->execute();
        $result = $stmt->get_result();
        return $result->num_rows > 0;
    }
?>