<?php

    include('../application_helper.php');
    $output['result'] = false;
    $output['message'] = "Something went wrong";
    if($data = validate_post_data(['access_token', 'admin_id', 'location_id', 'user_name', 'profile_name', 'password', 'mobile_number', 'email_id'])){
        include('../db.php');
        if(validate_admin($connection,  $data['access_token'], $data['admin_id'])){
            if(is_super_admin($connection, $data['admin_id'])){
                if(is_already_exist($connection, $data['user_name'])){
                    $output['result'] = false;
                    $output['message'] = "User '".$data['user_name']."' already exist";
                } else {
                    $password = hash_password($data['password']);
                    $query = "INSERT INTO admin_master(location_id,profile_name,user_name,email_id,mobile_number,password_hash) VALUES(?,?,?,?,?,?)";
                    $stmt=$connection->prepare($query);
                    $stmt->bind_param("ssssss",$data['location_id'],$data['profile_name'],$data['user_name'],$data['email_id'],$data['mobile_number'],$password);
                    $stmt->execute();
                    $stmt->close();
                    $output['result'] = true;
                    $output['message'] = "Successfully created new admin";
                }
            }
        }
    }  
    print_as_json($output);
    
    function is_already_exist($connection , $title){
        $query = "Select * FROM admin_master WHERE user_name = ?";
        $stmt=$connection->prepare($query);
        $stmt->bind_param("s", $title);
        $stmt->execute();
        $result = $stmt->get_result();
        $stmt->close();
        return $result->num_rows > 0;
    }