<?php

    include('../application_helper.php');
    $output['result'] = false;
    $output['message'] = "Somthing went wrong please try again later.";
    if($admin_data = validate_post_data(['access_token', 'admin_id'])){
        include('../db.php');
        if(validate_admin($connection, $admin_data['access_token'], $admin_data['admin_id'])){
            $data = validate_post_data(['coupon_note']);
            if($data){
                $query = "INSERT INTO  coupon_master(coupon_code, coupon_note, admin_id, created_at ) VALUES(?, ?, ?, ?)";
                $stmt=$connection->prepare($query);
            	$created_at = date('Y-m-d H:i:s');
            	$coupon_code = generate_coupon_code($connection);
                $stmt->bind_param("ssss",$coupon_code, $data['coupon_note'],$admin_data['admin_id'], $created_at);
                $stmt->execute();
                $stmt->close();
                $output["result"] = true;
                $output["message"] =  "Created new coupon code ";
            }
        }
    }
    
    print_as_json($output);
    
    
    function generate_coupon_code($connection){
        $code = build_coupon_code();
        while (check_coupon_code($connection, $code)) {
            $code = build_coupon_code();
        }
        return $code;
    }
    
    function check_coupon_code($connection, $coupon_code){
        $query = "Select * FROM coupon_master WHERE coupon_code = ?";
        $stmt=$connection->prepare($query);
        $stmt->bind_param("s", $coupon_code);
        $stmt->execute();
        $result = $stmt->get_result();
        $output = $result->fetch_assoc();
        return (bool) ($output);
    }
    
    function build_coupon_code(){
        $chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $coupon = "";
        for ($i = 0; $i < 10; $i++) {
            $coupon .= $chars[mt_rand(0, strlen($chars)-1)];
        }
        return $coupon;
    }
    