<?php

require __DIR__.'/vendor-firebase/autoload.php';

use Kreait\Firebase\Factory;
use Kreait\Firebase\Messaging\Notification;
use Kreait\Firebase\Contract\Messaging;
use Kreait\Firebase\Messaging\CloudMessage;
use Kreait\Firebase\Exception\FirebaseException;
use Kreait\Firebase\Contract\Auth;





function validate_post_data($inputs = array()): array {
    $result = array();
    foreach ($inputs as $input) {
        $TEMP_INPUT = $_POST[$input] ?? null;
        if ($TEMP_INPUT != null) {
            $result[$input] = $TEMP_INPUT;
        } else {
            $result = array();
            break;
        }
    }
    return $result;
}

function print_as_json($data){

    array_walk_recursive(
        $data,
        function(&$v) {
            if (is_numeric($v)) {
                $v = strval($v);
            }
        }
    );
    echo json_encode($data, JSON_PRETTY_PRINT);
}

function real_escape_string($db, $data = array()){
    foreach ($data as $key => $value) {
        $data[$key] = mysqli_real_escape_string($db, $value);
    }
    return $data;
}


function hash_password($password){
    return md5("skdhsn39!5".strrev($password)."*4");
}

function generate_merchant_access_token($connection, $merchant_id){
    $access_token = md5("sdkhsd@!!@".time()."28379d".strrev($merchant_id));
    $query = "INSERT INTO  merchant_access_token(merchant_id, access_token, created_at) VALUES(?, ?,?)";
    $stmt=$connection->prepare($query);
    $created_at = date('Y-m-d');
    $stmt->bind_param("sss", $merchant_id, $access_token, $created_at);
    $stmt->execute();
    //$stmt->close();
    return $access_token;
}

function validate_merchant($connection, $access_token, $merchant_id){
    $query = "Select * FROM merchant_access_token WHERE merchant_id = ? AND access_token = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("ss", $merchant_id, $access_token);
    $stmt->execute();
    $result = $stmt->get_result();
    $output = $result->fetch_assoc();
    $stmt->close();
    //return $merchant_id ;
    if($output){
        return $merchant_id;
    } else if(isset($_POST['admin_id'])) {
        if(validate_admin($connection, $access_token, $_POST['admin_id'])){
            return $merchant_id;
        } else {
            return 0;
        }
    } else {
        return 0;
    }
}

function generate_admin_access_token($connection, $admin_id){
    $access_token = md5("sdkhsd@!!@".time()."28379d".strrev($admin_id));
    $query = "INSERT INTO  admin_access_token(admin_id, access_token, created_at) VALUES(?, ?,?)";
    $stmt=$connection->prepare($query);
    $created_at = date('Y-m-d');
    $stmt->bind_param("sss", $admin_id, $access_token, $created_at);
    $stmt->execute();
    //$stmt->close();
    return $access_token;
}

function validate_admin($connection, $access_token, $admin_id){
    $query = "Select * FROM admin_access_token WHERE admin_id = ? AND access_token = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("ss", $admin_id, $access_token);
    $stmt->execute();
    $result = $stmt->get_result();
    $output = $result->fetch_assoc();
    return ($output) ? $output['admin_id'] : 0;
}

function generate_user_access_token($connection, $user_id){
    $access_token = md5("sdkhsd@!!@".time()."28379d".strrev($user_id));
    $query = "INSERT INTO  user_access_token(user_id, access_token, created_at) VALUES(?,?,?)";
    $stmt=$connection->prepare($query);
    $created_at = date('Y-m-d');
    $stmt->bind_param("sss", $user_id, $access_token, $created_at);
    $stmt->execute();
    //$stmt->close();
    return $access_token;
}

function validate_user($connection, $access_token, $user_id){
    $query = "Select * FROM user_access_token WHERE user_id = ? AND access_token = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("ss", $user_id, $access_token);
    $stmt->execute();
    $result = $stmt->get_result();
    $output = $result->fetch_assoc();
    return ($output) ? $output['user_id'] : 0;
}

function get_user_id_from_mobile_number($connection, $mobile_number){
    $query = "Select user_id FROM user_master WHERE mobile_number = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $mobile_number);
    $stmt->execute();
    $result = $stmt->get_result();
    if($result->num_rows > 0){
      $output = $result->fetch_assoc();
      return $output['user_id'];
    }
    return false;
}

function is_super_admin($connection,$admin_id){
    $query = "Select * FROM admin_master WHERE admin_id = ? AND priority_id  = 1";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $admin_id);
    $stmt->execute();
    $result = $stmt->get_result();
    return $result->num_rows > 0;
}

function is_merchant_username_available($connection, $user_name){
    $query = "Select * FROM shop_details WHERE name = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $user_name);
    $stmt->execute();
    $result = $stmt->get_result();
    $output  = $result->fetch_assoc();
    return !((bool)($output));
}

function is_merchant_phone_number_available($connection, $phone_number){
    $query = "Select * FROM shop_details WHERE phone_number = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $phone_number);
    $stmt->execute();
    $result = $stmt->get_result();
    $output  = $result->fetch_assoc();
    return !((bool)($output));
}

function is_user_phone_number_available($connection, $phone_number){
    $query = "Select * FROM user_master WHERE mobile_number = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $phone_number);
    $stmt->execute();
    $result = $stmt->get_result();
    $output  = $result->fetch_assoc();
    return !((bool)($output));
}

function is_admin_username_available($connection, $user_name){
    $query = "Select * FROM admin_master WHERE user_name = ?";
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $user_name);
    $stmt->execute();
    $result = $stmt->get_result();
    $output  = $result->fetch_assoc();
    return !((bool)($output));
}

function get_location_title($connection, $locationt_id){
    $query = "SELECT * FROM location  WHERE location_id  = ? ";//
    $stmt=$connection->prepare($query);
    $stmt->bind_param("s", $locationt_id);
    $stmt->execute();
    $result = $stmt->get_result();
    $output = $result = $result->fetch_assoc();
    return ($output) ? $output['location_title'] : "Select location";
}

//include('db.php');
//echo get_merchant_id_by_token($connection,"f4a3cf2613e1eec8ff9668af13604210");

//print_r(image_upload("/home/jcizone19/public_html/Ente_Naadu/images/","https://jcizone19.in/Ente_Naadu/images/", "sample"));

function image_upload($target_dir, $base_url, $file_name){
    $output['result'] = true;
    $output['image_url'] = "";
    $output['message'] = "";
    $imageFileType = strtolower(pathinfo($_FILES[$file_name]["name"],PATHINFO_EXTENSION));
    if(isset($_POST["submit"])) {
      $check = getimagesize($_FILES[$file_name]["tmp_name"]);
      if($check !== false) {
        $output['result'] = false;
        $output['message'] = "Invalid image files";
      }
    }
    if ($_FILES[$file_name]["size"] > 5000000) {
        $output['result'] = false;
        $output['message'] = "Image is too large";
    }
    
    if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg" ) {
        $output['result'] = false;
        $output['message'] = "Image must be in jpg,png,jpeg formats";
    }
    if ($output['result']) {
        $new_file_name  = "img_".uniqid() . time().rand(999,999999).'.'.$imageFileType;
        $destination  = $target_dir.$new_file_name;
        
      if (move_uploaded_file($_FILES[$file_name]["tmp_name"], $destination)) {
        $output['image_url'] = $base_url.$new_file_name;
      }
    }
    return $output;
}

function send_sms_account_details($user_name, $password, $mobile_number){
    $apiKey = urlencode('MzQ3MDc1MzM1MTM3NTM3MzU2NzQ3NDY1NWE0OTU2NzU=');
    $numbers = array($mobile_number);
    $sender = urlencode('TXTLCL');
    $message = rawurlencode("Ente Naadu Registration details \n Username : $username \n Password :$password");
    $numbers = implode(',', $numbers);
    $data = array("apikey" => $apiKey, "numbers" => $numbers, "sender" => $sender, "message" => $message);
    $ch = curl_init('https://api.textlocal.in/send/');
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);
    // Process your response here
    //echo $response;
}


//fireabse codes
function send_topic_notification($title, $message, $topic = 'ente_naadu'){
    try {
        $factory = (new Factory)->withServiceAccount('./credentials/ente-naadu-3abdb-firebase-adminsdk-t3yac-3d1dcc1979.json');
        $messaging = $factory->createMessaging();
        $notification = Notification::create($title, $message);
        $message = CloudMessage::withTarget('topic', $topic)->withNotification($notification);
        $messaging->send($message);
        echo " reached";
    } catch (FirebaseException $e) {
        echo 'An error has occurred while working with the SDK: '.$e->getMessage;
    }
}

function validate_id_token($token, $mobile_number){//10 dig mobile no country code
    		$output = false;
		    if(strlen($token) > 750){
			    $factory = (new Factory())  ->withServiceAccount('/home/jcizone19/public_html/Ente_Naadu//credentials/ente-naadu-3abdb-firebase-adminsdk-t3yac-3d1dcc1979.json');
			    $auth = $factory->createAuth();
			    try {
			        $verifiedIdToken = $auth->verifyIdToken($token);
			        $uid = $verifiedIdToken->getClaim('sub');
			        $user = $auth->getUser($uid);
			        $mobile = substr($user->phoneNumber, 3);
			        return $mobile == $mobile_number;
			    } catch (InvalidToken $e) {
			      // echo $e->getMessage();//coment in production
			    }
			}
			return $output;
}





?>