<?php
    include('../application_helper.php');
    include('../user/cart_helper.php');
    $output['result'] = false;
    $output['item_list'] = [];
    if($data = validate_post_data(['access_token', 'merchant_id', 'order_id'])){
        include('../db.php');
        if(validate_merchant($connection, $data['access_token'], $data['merchant_id'])){
          
          $query = " SELECT order_master.*, order_status.status_text, order_address.*, ";
          $query .= " user_master.user_name, user_master.mobile_number, user_master.address, user_master.mail_id";
          $query .= " FROM  order_master ";
          $query .= " JOIN order_status ON order_master.status_id = order_status.status_id ";
          $query .= " JOIN order_address ON order_address.address_id = order_master.address_id  ";
          $query .= " JOIN user_master ON user_master.user_id = order_master.user_id ";
          $query .= " WHERE order_master.order_id = ? ";

          $stmt = $connection->prepare($query);
          $stmt->bind_param("s",$data['order_id']);
          $stmt->execute();
          $result = $stmt->get_result();
          if($result->num_rows > 0){
            $output = $result->fetch_assoc();
            $output['result'] = true;
            $output['item_list'] = []; //
          }
          $stmt->close();
          
          if($output['result']){
            $query = "select order_items.*, product_details.*, shop_details.shop_name ";
            $query .= " FROM order_items ";
            $query .= "JOIN product_details ON order_items.product_id = product_details.product_id ";
            $query .= "JOIN shop_details ON shop_details.id = product_details.shop_id ";
            $query .= "WHERE order_items.order_id = ? ";

            $stmt=$connection->prepare($query);
            $stmt->bind_param("s",$data['order_id']);
            $stmt->execute();
            $result = $stmt->get_result();
            $stmt->close();
            $output['order_count'] = $result->num_rows;
            if($output['order_count'] > 0){
                $output['result'] = true;
                while($row = $result->fetch_assoc()){
                    array_push($output['item_list'],$row);
                }
            }
          }
        }
    }
    print_as_json($output);
?>
    
