<?php

    include('../application_helper.php');
    $data = validate_post_data(['location_id', 'category_id', 'name', 'password','shop_name', 'address', 'phone_number', 'id_token']);
    $output['result'] = false;
    $output['message'] = "Somthing went wrong please try again later.";
    if($data){
        include('../db.php');
        $data = real_escape_string($connection, $data);
        // if(!is_valid_coupon($connection,$data['coupon_code'])){
        //     $output['result'] = false;
        //     $output['message'] = "Invalid coupon code, try again with a valid coupon code";
        // }
        if(!validate_id_token($data['id_token'], $data['phone_number'])){
            $output['result'] = false;
            $output['message'] = "Unable to continue with your mobile number";
        }
        if(!is_merchant_username_available($connection, $data['name'])){
            $output['result'] = false;
            $output['message'] = "Username already taken, try with another one";
        }
        else if(!is_merchant_phone_number_available($connection, $data['phone_number'])){
            $output['result'] = false;
            $output['message'] = "Number already taken, try with another one";
        }
        else {        
            $data['password'] = hash_password($data['password']); //replacing password its hash 
            $query = "INSERT INTO  shop_details(location_id,category_id,name,password,shop_name,address,phone_number,phone_number1,phone_number2,whatsapp_number,email,website,facebook,insta,map,created_at,image) ";
            $query .= "VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?)";
            $stmt=$connection->prepare($query);
            if($stmt){
                $phone_number1 = $_POST['phone_number1'] ?? "";
                $phone_number2 = $_POST['phone_number2'] ?? "";
                $whatsapp_number = $_POST['whatsapp_number'] ?? "";
                $email = $_POST['email'] ?? "";
                $website = $_POST['website'] ?? "";
                $facebook = $_POST['facebook'] ?? "";
                $insta = $_POST['insta'] ?? "";
                $map = $_POST['map'] ?? "";
                $created_at = date('Y-m-d');
                $image = "";
                $stmt->bind_param("sssssssssssssssss",$data['location_id'], $data['category_id'], $data['name'], $data['password'], $data['shop_name'], $data['address'], $data['phone_number'],$phone_number1,$phone_number2, $whatsapp_number, $email, $website, $facebook, $insta, $map, $created_at, $image);
                $stmt->execute();
                $output["merchant_id"] = $stmt->insert_id;
                $output["access_token"] = generate_merchant_access_token($connection, $output["merchant_id"]);
                $stmt->close();
                $output["result"] = true;
                $output["location_id"] = $data['location_id'];
                $output["location_title"] = get_location_title($connection, $data['location_id']);
                $output["message"] =  "Registered successfully";
                //update_coupon_usage($connection, $data['coupon_code'], $output["merchant_id"]); //mark coupon as used once
                $output['result'] = true;
                $output['message'] = "Registration complete";
            }
            
        }
        
    }
    echo json_encode($output, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);

    
    

    function is_valid_coupon($connection,$coupon_code){
        $sql = "select * from coupon_master WHERE coupon_code = ? AND is_active = 1";
        $stmt = $connection->prepare($sql); 
        $stmt->bind_param("i", $coupon_code);
        $stmt->execute();
        $result = $stmt->get_result();
        $output  = $result->fetch_assoc();
        return (bool) $output;
    }
    
    function update_coupon_usage($connection, $coupon_code, $merchant_id){
        $sql = "UPDATE coupon_master SET is_active = 0, shop_id = ?, executed_at = NOW() WHERE coupon_code = ?";
        $stmt = $connection->prepare($sql); 
        $stmt->bind_param("ii", $merchant_id, $coupon_code);
        $stmt->execute();
    }

?>