<?php
    include ("db.php");
    $shop_id = $_POST['shop_id'] ?? 11;
    $sql = "select product_details.*,";
    $sql .= "shop_details.name AS shop_name, shop_details.id AS shop_id, ";
    $sql .= "IFNULL(offer_details.offer_price, product_price) offer_price ";
    $sql .= "FROM  product_details LEFT JOIN offer_details ON product_details.product_id = offer_details.product_id ";
    $sql .= "JOIN shop_details ON shop_details.id = product_details.shop_id ";
    $sql .= "WHERE product_details.shop_id = ? ";
    $sql .= "GROUP BY product_details.product_id";
    $stmt = $connection->prepare($sql); 
    $stmt->bind_param("i", $shop_id);
    $stmt->execute();
    $result = $stmt->get_result();
    $response = array();
    if($result->num_rows > 0){
        while($row = $result->fetch_assoc()){
            array_push($response,$row);
        }
    }
    $offers = [];
    $products = [];
    foreach($response as $key => $value){
        if($value['offer_price'] < $value['product_price'] ){
            $offers[] = $value;
        } else {
            $products[] = $value;  
        }
    }
    $response = array_merge($offers, $products);
    $connection->close();
    header('Content-Type: application/json');
    $output['product_list'] = $response;
    echo json_encode($output);

?>

