<?php
    require '../vendor/autoload.php';

    use Razorpay\Api\Api;
    use Razorpay\Api\Errors\SignatureVerificationError;

    $success = true;
    $error = "Payment Failed";
    include('../application_helper.php');
    include('./cart_helper.php');
    include('./razor_config.php');
    include('../db.php');
    $output['result'] = false;
    $output['message'] = "Unable to place your order, please try again later";
    if ($data = validate_post_data(['access_token', 'user_id', 'address_id', 'razorpay_order_id', 'razorpay_payment_id', 'razorpay_signature'])) {
        $attributes = array(
            'razorpay_order_id' => $data['razorpay_order_id'],
            'razorpay_payment_id' => $data['razorpay_payment_id'],
            'razorpay_signature' => $data['razorpay_signature']
        );
        try {
            $api = new Api(RAZOR_KEY_ID, RAZOR_KEY_SECRET);
            $api->utility->verifyPaymentSignature($attributes);
        } catch (SignatureVerificationError $e) {
            $success = false;
            // $error = 'Razorpay Error : ' . $e->getMessage();
        }
    }
    if ($success === true) {
        $verification_data = $api->payment->fetch($data['razorpay_payment_id']);
        $attributes['receipt_id'] = $verification_data->notes->receipt;
        update_order_receipt($connection, $attributes);
        $cart_data = get_cart_data($connection, $data['user_id']);
        $order_amount = (int)($cart_data['total_amount'] * 100);
        if ($verification_data->amount == $order_amount) {
            /**********************************************************/
            place_order($connection, $data['user_id'], $data['address_id'], $cart_data, 1, $attributes['receipt_id']);
            $output['result'] = true;
            $output["message"] = "Successfully placed your order";
            /**********************************************************/
        }
    }
    print_as_json($output);

