<?php

    include('../application_helper.php');
    $data = validate_post_data(['user_name', 'password','address', 'mobile_number', 'id_token','mail_id']);
    $output['result'] = false;
    $output['message'] = "Somthing went wrong please try again later.";
    if($data){
        include('../db.php');
        $data = real_escape_string($connection, $data);
        if(!validate_id_token($data['id_token'], $data['mobile_number'])){
            $output['result'] = false;
            $output['message'] = "Unable to continue with your mobile number";
        }
        else if(!is_user_phone_number_available($connection, $data['mobile_number'])){
            $output['result'] = false;
            $output['message'] = "Number already taken, try with another one";
        }
        else {   
            $data['password'] = hash_password($data['password']); //replacing password its hash 
            $query = "INSERT INTO  user_master(user_name, password,address, mobile_number, mail_id, created_at	) ";
            $query .= "VALUES(?, ?, ?, ?, ?, ?)";
            $stmt=$connection->prepare($query);
            if($stmt){
                $created_at	= date('Y-m-d H:i:s');
                $stmt->bind_param("ssssss",$data['user_name'], $data['password'], $data['address'], $data['mobile_number'], $data['mail_id'], $created_at);
                $stmt->execute();
                $output["user_id"] = $stmt->insert_id;
                $output["access_token"] = generate_user_access_token($connection, $output["user_id"]);
                $stmt->close();
                $output["result"] = true;
                $output["message"] =  "Registered successfully";
                $output['result'] = true;
            }
            
        }
        
    }
    echo json_encode($output, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);

    


?>